Program PCM_Sinusgenerator;
uses CRT;
Const BA = $3F8;             { COM1 }
var Frequenz : Integer;

procedure Oeffnen115200;
begin
  Port [BA+3]:=128;          { Baudeingabe aktivieren }
  Port [BA  ]:= 1;           { Baudrate - LSB, 115200 Baud }
  Port [BA+1]:=  0;          { Baudrate - MSB }
  Port [BA+3]:=  3;          { 8 Bits, No Parity, 1 Stop }
  Port [BA+4]:=  0;          { DTR = 0, CTS = 0 }
end;

procedure Senden  ( Wert : Byte );
   begin
     repeat
     until Port [BA+5] and 32 = 32; { Abfrage, ob Sendepuffer leer }
     Port [BA]:= (Wert);            { Byte an Sendepuffer ausgeben }
   end;


procedure Sinus (Frequenz: Integer);
var n : word;
    Anzahl, i : integer;
    Ausgabe, Eingabe: Byte;
    SendeByte, Bitwert : Byte;
    Puffer : Array [1..10000] of Byte;
begin
  Anzahl := round( 11520 / Frequenz);
  for n :=  1 to Anzahl do
    Puffer[n] := 128 + round (100 * sin (2 * Pi * ((n-1) / Anzahl)));
  Ausgabe:= 128;
  for n:= 1 to Anzahl do begin
    Ausgabe := Ausgabe + 5;
    Bitwert := 1;
    SendeByte := 0;
    Eingabe := Puffer[n];
    write (Eingabe,'   ');
    for i := 1 to 8 do begin
      if Eingabe < Ausgabe then begin
        SendeByte := SendeByte + Bitwert;
        Ausgabe := Ausgabe - 5 end
      else Ausgabe := Ausgabe + 5;
      BitWert := BitWert * 2;
    end;
    Ausgabe := Ausgabe - 5;
    Puffer[n] := SendeByte;
    writeln (Ausgabe);
  end;
  repeat
    Inline ($FA);
    for i:= 1 to 1000 do begin
      for n:= 1 to Anzahl do Senden (Puffer[n]);
    end;
    Inline ($FB);
  until KeyPressed;
end;

begin
  Oeffnen115200;
  writeln ('Frequenz in Hz?');
  readln (Frequenz);
  Sinus (Frequenz);
end.
