Program Spannungsmessung;
Uses Crt;
const  BA = $3F8;                  { COM 1 }
var  Spannung, Negativ, Positiv, Zeitfaktor : Real;

function Zaehler: Word;
var n : Integer;
begin
 N := 0;
 Inline ($FA);                     { Interrupt sperren }
 Port [BA+4] := 3;                 { DTR und RTS an }
 repeat
   N := N +1;                      { zhlen }
 until ((Port[BA+6] and 16)=0);    { bis CTS = 0 }
 Port[BA+4] := 2;                  { DTR aus, RTS bleibt an }
 Inline ($FB);                     { Interrupt freigeben }
 Zaehler := N;
end;

procedure Kalibrieren;
begin
  Zeitfaktor := -(Zaehler/ln(1-Negativ/(Positiv+Negativ)));
  delay (500);
end;

begin
  Negativ := 10.2;                 { Feineinstellung! }
  Positiv := 10.25;                { Feineinstellung! }
  Kalibrieren;
  repeat
    Spannung :=(Negativ+Positiv)*(1-exp(-Zaehler/Zeitfaktor))-Negativ;
    writeln (Spannung :3:2, ' V  ');
    delay (500);                   { Erholzeit }
  until KeyPressed;
end.
